package ass.excercises.cvi7.demo4;

import io.reactivex.netty.protocol.http.server.HttpServer;
import io.reactivex.netty.protocol.http.server.HttpServerBuilder;


import java.io.IOException;
import java.io.UncheckedIOException;
import java.nio.file.Files;
import java.nio.file.Paths;


import rx.Observable;
import javaslang.control.Try;

public class StaticServer {
	
	public static void main(String[] args) {
		//ExamplesEnvironment env = ExamplesEnvironment.newEnvironment(HelloWorldServer.class);

		HttpServer<String, String> server = new HttpServerBuilder<String, String>(ServerConfig.SERVER_PORT, 
        		(req, resp) ->
    				resp.writeBytesAndFlush(readFile(req.getPath()))
        ).build();

		server.startAndWait();
	}
	
	private static byte[] readFile(String filepath) {
		filepath = "document_root/" + filepath.replace("/", "");
		System.out.println("Requesting: '"+filepath+"'");
		try {
			return Files.readAllBytes(Paths.get(filepath));
		}catch(IOException ioe) {
			throw new UncheckedIOException(ioe);
		}
	}
	
}
